Attribute VB_Name = "modUtilita"
'================================================================
' Descrizione.....: Collezione di routines e costanti di utilita'
'                   per le "Curve Famose".
' Nome dei Files..: modUtilita.bas
' Data............: 28/6/2002
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 sotto Windows NT.
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://members.xoom.virgilio.it/flanguasco/
'                   http://www.flanguasco.org
'================================================================
'
'   Nota: le Subs Quadro e CMDialog_Files sono modificate
'         rispetto alla versione standard.
'
Option Explicit
'
Public Const PI# = 3.14159265358979     ' 4# * Atn(1#).
Public Const PI2# = 2# * PI
Public Const PI_2# = PI / 2#            ' 90 in [Rad].
Public Const SqrPI# = 1.77245385090552  ' Sqr(PI).
Public Const Log10# = 2.30258509299405
'
'--- GetLocale: ----------------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_SDECIMAL& = &HE
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDATE& = &H1D
Private Const LOCALE_STIME& = &H1E
Public Function DMAX1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function DMIN1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vDMin > vD(J) Then vDMin = vD(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function FresnelS(ByVal ThetaI#, ByVal ThetaF# _
    , Optional ByVal Eps# = 0.0001) As Double
'
'   Routine per il calcolo dell' integrale di Sin(PIt/2)dt
'   compreso tra ThetaI e ThetaF.
'
'   Tradotto dalla Subroutine FORTRAN di:
'       Mathematical Methods for Digital Computers  Vol. II
'       di A. Ralston, H. S. Wilf
'       John Wiley & Sons, Inc.
'
    Dim K&, N&, J&, L&, U&, V&
    Dim h#, ThetaH#, Sig#
    Dim w#(1 To 50, 1 To 50)
'
    K = 0
    h = ThetaF - ThetaI
    w(1, 1) = ((Sin(ThetaI * ThetaI * PI_2) + Sin(ThetaF * ThetaF * PI_2)) * h) / 2#
'
    Do
        K = K + 1
        h = h / 2#
        Sig = 0#
        N = 2 ^ (K - 1)
        For J = 1 To N
            ThetaH = ThetaI + CDbl(2 * J - 1) * h
            Sig = Sig + Sin(ThetaH * ThetaH * PI_2)
        Next J
'
        w(K + 1, 1) = w(K, 1) / 2# + h * Sig
        For L = 1 To K
            U = K + 1 - L
            V = L + 1
            w(U, V) = (4# ^ (V - 1) * w(U + 1, V - 1) _
                    - w(U, V - 1)) / (4# ^ (V - 1) - 1#)
        Next L
    Loop While Abs(w(U, V) - w(U, V - 1)) > Eps
'
    FresnelS = w(1, V)
'
'
'
End Function
Public Function FresnelC(ByVal ThetaI#, ByVal ThetaF# _
    , Optional ByVal Eps# = 0.0001) As Double
'
'   Routine per il calcolo dell' integrale di Cos(PIt/2)dt
'   compreso tra ThetaI e ThetaF.
'
'   Tradotto dalla Subroutine FORTRAN di:
'       Mathematical Methods for Digital Computers  Vol. II
'       di A. Ralston, H. S. Wilf
'       John Wiley & Sons, Inc.
'
    Dim K&, N&, J&, L&, U&, V&
    Dim h#, ThetaH#, Sig#
    Dim w#(1 To 50, 1 To 50)
'
    K = 0
    h = ThetaF - ThetaI
    w(1, 1) = ((Cos(ThetaI * ThetaI * PI_2) + Cos(ThetaF * ThetaF * PI_2)) * h) / 2#
'
    Do
        K = K + 1
        h = h / 2#
        Sig = 0#
        N = 2 ^ (K - 1)
        For J = 1 To N
            ThetaH = ThetaI + CDbl(2 * J - 1) * h
            Sig = Sig + Cos(ThetaH * ThetaH * PI_2)
        Next J
'
        w(K + 1, 1) = w(K, 1) / 2# + h * Sig
        For L = 1 To K
            U = K + 1 - L
            V = L + 1
            w(U, V) = (4# ^ (V - 1) * w(U + 1, V - 1) _
                    - w(U, V - 1)) / (4# ^ (V - 1) - 1#)
        Next L
    Loop While Abs(w(U, V) - w(U, V - 1)) > Eps
'
    FresnelC = w(1, V)
'
'
'
End Function
Public Function DMAXVAL(dVet#()) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If dDMax < dVet(J) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function
Public Function DMINVAL(dVet#()) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If dDMin > dVet(J) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
Private Sub GetLocale(Optional ByRef DS$, Optional ByRef MS$, _
    Optional ByRef GS$, Optional ByRef TS$)
'
'   Trova i separatori del sistema:
'    DS$:   separatore decimale.
'    MS$:   separatore delle migliaia.
'    GS$:   separatore dei giorni.
'    TS$:   separatore delle ore.
'
    DS$ = "  "
    MS$ = "  "
    GS$ = "  "
    TS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_SDATE, GS$, Len(GS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STIME, TS$, Len(TS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
    GS$ = Left$(GS$, 1)
    TS$ = Left$(TS$, 1)
'
'
'
End Sub
Public Function Quadro(ByVal Foglio As PictureBox, _
    ByRef X0#, ByRef Xn#, ByRef Y0#, ByRef Yn#, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx& = 1, Optional PxN_X!, Optional PxN_Y!, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByRef tEsec!) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Parametri in ingresso:
'     Foglio:    PictureBox da scalare.
'     X0:        Valore minimo di ascissa da rappresentare.
'     Xn:        Valore massimo di ascissa da rappresentare.
'                Deve essere X0 < Xn.
'     Y0:        Valore minimo di ordinata da rappresentare.
'     Yn:        Valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: Stringa di formato dei valori sull' asse X.
'     FormatVY$: Stringa di formato dei valori sull' asse Y.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   Titolo del grafico.
'     UnitaX$:   Unita' (o titolo) dell' asse X.
'     UnitaY$:   Unita' (o titolo) dell' asse Y.
'     AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'     bGriglia:  Se True viene disegnata la griglia di riferimento:
'                se False viene fatta solo la scalatura di Foglio.
'    Parametri in uscita:
'     PxN_X:     Larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx [Pixels].
'     tEsec:     tempo impiegato a disegnare il quadro [s].
'
    Dim I&, XI!, D_X!, rrx!, YI!, D_Y!, rry!, Txt$
    Dim QxMin!, QxMax!, QyMin!, QyMax!, B0!, Bn!, TxW!
    Dim TitL!, TitT!, TitW!, TitH!, Po4_X!, Po4_Y!
    Const Log10! = 2.30258509299405 ' Log(10#)
    Const ScMin! = 0.0001           ' Ampiezza min. delle scale X e Y.
'
    tEsec = Timer
    On Error GoTo Quadro_ERR
    ' Verifica la correttezza delle scale:
    If X0 > Xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If Y0 > Yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
    ' Imposta i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Imposta una scala minima
    ' per l' asse X:
    If Xn - X0 < ScMin Then
        X0 = X0 - ScMin / 2!
        Xn = Xn + ScMin / 2!
    End If
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = Xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, 3))
    Xn = rrx * Ceil(Round(Xn / rrx, 3))
    D_X = Xn - X0
'
    ' Imposta una scala minima
    ' per l' asse Y:
    If Yn - Y0 < ScMin Then
        Y0 = Y0 - ScMin / 2!
        Yn = Yn + ScMin / 2!
    End If
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = Yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, 3))
    Yn = rry * Ceil(Round(Yn / rry, 3))
    D_Y = Yn - Y0
'
    ' Il bordo a destra dipende dalla
    ' presenza, o meno, di un' etichetta:
    If UnitaX$ = "" Then
        Bn = D_X / 20!
    Else
        Bn = D_X / 10!
    End If
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxW = Foglio.TextWidth(Format$(Y0, FormatVY$) & " ")
    If TxW < Foglio.TextWidth(Format$(Yn, FormatVY$) & " ") Then
        TxW = Foglio.TextWidth(Format$(Yn, FormatVY$) & " ")
    End If
    B0 = TxW * (D_X + Bn) / (Foglio.ScaleWidth - TxW)
    If B0 < D_X / 10! Then B0 = D_X / 10!
'
    ' Imposta i bordi orizzontali
    ' e verticali:
    QxMin = X0 - B0
    QxMax = Xn + Bn
    QyMin = Y0 - D_Y / 10!
    QyMax = Yn + D_Y / 7!
'
    ' Imposta la scala e cancella il Foglio:
    Foglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
    Foglio.Line (QxMin, QyMin)-(QxMax, QyMax), Foglio.BackColor, BF ' Questo e' piu' veloce
                                                                    ' di Foglio.Cls.
'
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
'
    ' Calcola larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcola larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)
'
    ' Verifica se e' richiesto il
    ' disegno della griglia:
    If Not bGriglia Then GoTo Fine
'
    Foglio.DrawMode = vbCopyPen
    Foglio.DrawWidth = 1
    Foglio.DrawStyle = vbDash
    Foglio.ForeColor = vbGreen
    ' Traccia la griglia verticale e scrive
    ' i valori dell' asse X:
    For XI = X0 To Xn + 0.1 * rrx Step rrx
        Foglio.Line (XI, Y0)-(XI, Yn), vbGreen
        Txt$ = Format$(XI, FormatVX$)
        ' Verifica che il formato scelto non
        ' induca ad errori di rappresentazione:
        If Abs(XI - Val(Txt$)) < rrx / 10 Then
            Foglio.CurrentX = XI - Foglio.TextWidth(Txt$) / 2!
            Foglio.CurrentY = Y0 - D_Y / 70!
            Foglio.Print Txt$;
        End If
    Next XI
    ' Scrive l' etichetta dell' asse X:
    If UnitaX$ <> "" Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.CurrentY = Y0 - D_Y / 70!
        Foglio.Print UnitaX$;
    End If
    ' Traccia l' asse Y:
    If (X0 <= 0!) And (0! <= Xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, Y0)-(0!, QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(-Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
    End If
'
    Foglio.DrawStyle = vbDash
    ' Traccia la griglia orizzontale e scrive
    ' i valori dell' asse Y:
    For YI = Y0 To Yn + 0.1 * rry Step rry
        Foglio.Line (X0, YI)-(Xn, YI), vbGreen
        Txt$ = Format$(YI, FormatVY$)
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = YI - Foglio.TextHeight(Txt$) / 2!
        Foglio.Print Txt$;
    Next YI
    ' Scrive l' etichetta dell' asse Y:
    If UnitaY$ <> "" Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QyMax
        Foglio.Print UnitaY$;
    End If
    ' Traccia l' asse X:
    If (Y0 <= 0!) And (0! <= Yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (X0, 0!)-(QxMax - D_X / 30!, 0!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, -Po4_Y / 2!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, Po4_Y / 2!), vbGreen
    End If
'
    ' Scrive il titolo del grafico:
    If Titolo$ <> "" Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifica che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglia:
        Else
            TitL = Foglio.ScaleLeft
            Txt$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Txt$)) / TitW)) & Txt$
        End If
        TitT = QyMax
        ' Cancella l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
Fine:
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, " Quadro/" & Err.Source
    End If
    tEsec = Timer - tEsec
'
'
'
End Function
Public Sub Trasforma(ByVal X0#, ByVal Y0#, ByVal Rot#, ByVal Tx#, ByVal Ty# _
    , ByRef Xt#, ByRef Yt#)
'
'   Routine per la roto-traslazione di un punto:
'
'   X0, Y0: coordinate del punto da trasformare.
'   Rot:    rotazione del punto in [radianti].
'   Tx, Ty: traslazione del punto nelle direzioni x e y.
'   Xt, Yt: coordinate finali del punto trasformato.
'   Il centro di rotazione e' l' origine degli assi.
'
    ' Rotazione:
    Xt = X0 * Cos(Rot) - Y0 * Sin(Rot)
    Yt = X0 * Sin(Rot) + Y0 * Cos(Rot)
'
    ' Traslazione:
    Xt = Xt + Tx
    Yt = Yt + Ty
'
'
'
End Sub
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If X = Int(X) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Public Function CMDialog_Files(ByVal CMDialog As CommonDialog, ByVal Oper$, _
    ByVal Tipo$, ByVal Ext$, Optional ByVal DirNome$ = "", _
    Optional ByVal FileNome$ = "", Optional ByVal Titolo$ = "") As String
'
'   Imposta i valori di una finestra per la gestione dei Files
'   e ritorna il nome completo del File scelto.
'   La gestione degli errori (e.g. cdlCancel) va' fatta nella
'   routine chiamante.
'
'   Parametri:
'    CMDialog:  e' il controllo Common Dialog che si intende usare.
'    Oper$:     operazione da eseguire (solo "Save" o "Open").
'    Tipo$:     tipo dei files da proporre (e.g. "Filtri IIR").
'    Ext$:      estensioni dei files da proporre (e.g. "*.dat[;*.txt]").
'    DirNome$:  Folder di default.
'    FileNome$: nome del File di default.
'    Titolo$:   titolo della finestra.
'
    Dim Filter$
'
    On Error GoTo CMDialog_Files_ERR
'
    If Oper$ <> "Open" And Oper$ <> "Save" Then Err.Raise 5
'
    ' Prepara ed imposta tipo ed estensioni dei
    ' files da proporre:
    Filter$ = Tipo$ & " (" & Ext$ & ")|" & Ext$ & "|"
    Filter$ = Filter$ & "Tutti i Files (*.*)|*.*"
    CMDialog.Filter = Filter$
    CMDialog.FilterIndex = 1
'
    ' Imposta il Folder di default:
    If DirNome$ <> "" Then
        CMDialog.InitDir = DirNome$
    Else
        CMDialog.InitDir = App.Path
    End If
'
    ' Imposta il File Name di default:
    If FileNome$ <> "" Then
        CMDialog.FileName = FileNome$
    Else
        If Oper$ = "Open" Then
            CMDialog.FileName = ""
        ElseIf Oper$ = "Save" Then
            CMDialog.FileName = Left$(Ext$, 5)
        End If
    End If
'
    ' Scrive il titolo della finestra:
    CMDialog.DialogTitle = " " & Titolo$
'
    ' Controlla l' esistenza del File, chiede conferma
    ' se File Already Exists, nasconde la casella Read Only:
    CMDialog.Flags = cdlOFNFileMustExist + cdlOFNOverwritePrompt _
                   + cdlOFNHideReadOnly
    ' e permette il Cancel:
    CMDialog.CancelError = True
'
    ' Apre la finestra con
    ' l' operazione richiesta:
    If Oper$ = "Open" Then
        CMDialog.ShowOpen
    ElseIf Oper$ = "Save" Then
        CMDialog.ShowSave
    End If
'
    CMDialog_Files = CMDialog.FileName
'
'
CMDialog_Files_ERR:
    ' Reimposta il Folder di default:
    ChDir App.Path & "\"
    ' Rimanda alla gestione degli errori
    ' nella routine chiamante:
    If (Err <> 0) Then Err.Raise Err.Number
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef PName$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'    Full$  = Nome completo del File.
'    PName$ = Path del File (con \ finale).
'    FName$ = Nome del File con Estensione.
'    Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Public Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA%, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal NEG As Boolean = False _
    , Optional ByVal ChrAdd$ = "0") As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Questa versione permette di passare il carattere
'   addizionale ChrAdd$ da ritornare come valido.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%, KeyAdd%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    KeyAdd = Asc(ChrAdd$)
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE, KeyAdd
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Public Function Tanh(ByVal z As Double) As Double
'
'   Ritorna la tangente iperbolica di z:
'
    Tanh = (Exp(z) - Exp(-z)) / (Exp(z) + Exp(-z))
'
'
'
End Function
Public Function Cosh(ByVal z As Double) As Double
'
'   Ritorna il coseno iperbolico di z:
'
    Cosh = (Exp(z) + Exp(-z)) / 2#
'
'
'
End Function
